<template>
	<div class="FieldsViewSortBy">
		<div class="FieldsViewSortBy-header">
			<h4>Sort By</h4>
			<v-spacer></v-spacer>
			<button class="FieldsViewRecentActivityFilter-clear primary--text" @click="clearFilter">Clear filter</button>
		</div>
		<v-divider></v-divider>
		<v-radio-group @change="handleRadioChange" :value="currentRadioValue">
			<v-radio v-for="option in options" :key="option.label" :value="option.value" :label="option.label"></v-radio>
		</v-radio-group>
	</div>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';

const options = [
	{
		label: 'Field Name',
		value: { sortBy: 'name', sortDir: 'ASC' },
	},
	{
		label: 'Group',
		value: { sortBy: 'groupName', sortDir: 'ASC' },
	},
	{
		label: 'Producer',
		value: { sortBy: 'producerName', sortDir: 'ASC' },
	},
	{
		label: 'Status',
		value: { sortBy: 'status', sortDir: 'DESC' },
	},
];

export default defineComponent({
	setup(_, { root }) {
		const sortBy = computed(() => root.$store.getters['fieldsView/getSortBy']);
		const sortDir = computed(() => root.$store.getters['fieldsView/getSortDir']);
		const currentRadioValue = computed(
			() =>
				options.find((option) => sortBy.value === option.value.sortBy && sortDir.value === option.value.sortDir)
					?.value || null
		);
		const handleRadioChange = (event: any) => {
			root.$store.dispatch('fieldsView/changeSort', event);
		};
		const clearFilter = () => {
			root.$store.dispatch('fieldsView/changeSort', { sortBy: null, sortDir: null });
		};

		return {
			currentRadioValue,
			handleRadioChange,
			clearFilter,
			options,
		};
	},
});
</script>

<style>
.FieldsViewSortBy {
	padding: 6px 8px;
	background: #fff;
}

.FieldsViewSortBy-header {
	display: flex;
}

.FieldsViewSortBy .v-input--radio-group {
	margin-top: 0;
}

.FieldsViewSortBy .v-input--radio-group .v-messages {
	display: none;
}

.FieldsViewSortBy .v-divider {
	margin: 4px 0 8px 0;
}
</style>
